---
title: "Live Bing Organic SERP Advanced"
url: "https://docs.dataforseo.com/v3/serp/bing/organic/live/advanced/"
date: "2026-06-06"
---

## Live Bing Organic SERP Advanced

Live SERP provides real-time data on top 100 search engine results for the specified keyword, search engine, and location. This endpoint will supply a complete overview of featured snippets and other extra elements of SERPs.

 

 

 ![checked](https://docs.dataforseo.com/v3/wp-content/themes/dataforseo/assets/img/icons/checked-circle.svg) POST  https://api.dataforseo.com/v3/serp/bing/organic/live/advanced     

      

Pricing

 Your account will be charged for each request.  
The cost can be calculated on the [Pricing](https://dataforseo.com/pricing/serp/serp-api "Pricing") page.

 

 All POST data should be sent in the [JSON](https://en.wikipedia.org/wiki/JSON) format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live SERP API call can contain only one task.

Below you will find a detailed description of the parameters that are required or recommended for setting a task.

### Main Parameters

 | Field name | Type | Description |
|---|---|---|
| `keyword` | string | *keyword*   **required field**   you can specify **up to 700 characters** in the `keyword` field   **all %## will be decoded (plus character '+' will be decoded to a space character)**   if you need to use the "%" character for your `keyword`, please specify it as "%25";   if you need to use the “+” character for your `keyword`, please specify it as “%2B”;  learn more about rules and limitations of `keyword` and `keywords` fields in DataForSEO APIs in this [Help Center article](https://dataforseo.com/help-center/rules-and-limitations-of-keyword-and-keywords-fields-in-dataforseo-apis) |
| `location_code` | integer | *search engine location code*   **required field if you don't specify** `location_name` or `location_coordinate`   **if you use this field, you don't need to specify `location_name` or `location_coordinate`**   you can receive the list of available locations of the search engines with their `location_code` by making a separate request to the `https://api.dataforseo.com/v3/serp/bing/locations`   example:   `2840` |
| `language_code` | string | *search engine language code*   **required field if you don't specify** `language_name`   **if you use this field, you don't need to specify `language_name`**   you can receive the list of available languages of the search engine with their `language_code` by making a separate request to the `https://api.dataforseo.com/v3/serp/bing/languages`   example:   `en` |
| `depth` | integer | *parsing depth*   optional field   number of results in SERP   default value: `10`   max value: `200`    **Your account will be billed per each SERP containing up to 10 results;**   Setting depth above 10 may result in additional charges [if the search engine returns more than 10 results](https://dataforseo.com/help-center/how-many-results-scraped);   The cost can be calculated on the [Pricing](https://dataforseo.com/pricing/serp/bing-organic-serp-api "Pricing") page. |
| `device` | string | *device type*   optional field   return results for a specific device type   can take the values:`desktop`, `mobile`   default value: `desktop` |

   
Below you will find a drop-down list with the additional parameters you can use for setting a task.  
  ### Additional Parameters

 | Field name | Type | Description |
|---|---|---|
| `location_name` | string | *full name of search engine location*   **required field if you don't specify** `location_code` or `location_coordinate`   **if you use this field, you don't need to specify `location_code` or `location_coordinate`**   you can receive the list of available locations of the search engine with their `location_name` by making a separate request to the `https://api.dataforseo.com/v3/serp/bing/locations`   example:   `London,England,United Kingdom` |
| `language_name` | string | *full name of search engine language*   **required field if you don't specify** `language_code`   **if you use this field, you don't need to specify `language_code`**   you can receive the list of available languages of the search engine with their `language_name` by making a separate request to the `https://api.dataforseo.com/v3/serp/bing/languages`   example:   `English` |
| `os` | string | *device operating system*   optional field   if you specify `desktop` in the `device` field, choose from the following values: `windows`, `macos`   default value: `windows`   if you specify `mobile` in the `device` field, choose from the following values: `android`, `ios`   default value: `android` |
| `tag` | string | *user-defined task identifier*   optional field   *the character limit is 255*   you can use this parameter to identify the task and match it with the result   you will find the specified `tag` value in the `data` object of the response |
| `target` | string | *target domain, subdomain, or webpage to get results for*   optional field   a domain or a subdomain should be specified without `https://` and `www.`   note that the results of `target`-specific tasks will only include SERP elements that contain a `url` string;   you can also use a wildcard (‘\*’) character to specify the search pattern in SERP and narrow down the results;   examples:   **`example.com`** - returns results for the website's home page with URLs, such as `https://example.com`, or `https://www.example.com/`, or `https://example.com/`;   **`example.com*`** - returns results for the domain, including all its pages;   **`*example.com*`** - returns results for the entire domain, including all its pages and subdomains;   **`*example.com`** - returns results for the home page regardless of the subdomain, such as `https://en.example.com`;   **`example.com/example-page`** - returns results for the exact URL;   **`example.com/example-page*`** - returns results for all domain's URLs that start with the specified string |
| `stop_crawl_on_match` | array | *array of targets to stop crawling*   optional field   specified as an array of target objects   each target object consists of one `match_type` field and one `match_value` field   **you can specify up to 10 target objects in this array**   if specified, the response will contain SERP results up to and including the specified `match_value`;   example:   `"stop_crawl_on_match":[{"match_value":"dataforseo.com","match_type":"with_subdomains"}]`   learn more about this parameter on our [Help Center](https://dataforseo.com/help-center/using-the-stop_crawl_on_match-parameter-in-serp-api)    **Your account will be billed for every SERP crawled until the conditions you specified in this array are met** |
| `match_type` | string | *target match type*   **required field if `stop_crawl_on_match` is specified**   type of match for the `match_value`   possible values:   `domain` – specific domain or subdomain   `with_subdomains` – main domain and subdomains   `wildcard` – wildcard pattern |
| `match_value` | string | *target domain, subdomain, or wildcard value*   **required field if `stop_crawl_on_match` is specified**   specify a target domain, subdomain, or wildcard value;   **Note:** domain or subdomain must be specified without a request protocol;   example: `"match_value": "dataforseo.com"`,   `"match_value": "/blog/post-*"` |
| `max_crawl_pages` | integer | *page crawl limit*   optional field   number of search results pages to crawl   default value: `1`   max value: `100`   **Note:** the `max_crawl_pages` and `depth` parameters complement each other;   learn more at [our help center](https://dataforseo.com/help-center/what-is-max-crawl-pages-and-how-does-it-work) |
| `search_param` | string | *additional parameters of the search query*   optional field   [get the list of available parameters and additional details here](https://dataforseo.com/help-center/bing-search-engine-parameters-and-how-to-use-them) |
| `calculate_rectangles` | boolean | *calculate pixel rankings for SERP elements in advanced results*   optional field   pixel ranking refers to the distance between the result snippet and top left corner of the screen;   [Visit Help Center to learn more&gt;&gt;](https://dataforseo.com/help-center/pixel-ranking-in-serp-api)   by default, the parameter is set to `false`   **Note:** you will be charged extra $0.002 for using this parameter |
| `browser_screen_width` | integer | *browser screen width*   optional field   you can set a custom browser screen width to calculate pixel rankings for a particular device;   can be specified within the following range: `240-9999`;   by default, the parameter is set to:   `1920` for `desktop`;   `360` for `mobile` on `android`;   `375` for `mobile` on `iOS`;   **Note:** to use this parameter, set `calculate_rectangles` to `true` |
| `browser_screen_height` | integer | *browser screen height*   optional field   you can set a custom browser screen height to calculate pixel rankings for a particular device;   can be specified within the following range: `240-9999`;   by default, the parameter is set to:   `1080` for `desktop`;   `640` for `mobile` on `android`;   `812` for `mobile` on `iOS`;   **Note:** to use this parameter, set `calculate_rectangles` to `true` |
| `browser_screen_resolution_ratio` | integer | *browser screen resolution ratio*   optional field   you can set a custom browser screen resolution ratio to calculate pixel rankings for a particular device;   can be specified within the following range: `0.5-3`;   by default, the parameter is set to:   `1` for `desktop`;   `3` for `mobile` on `android`;   `3` for `mobile` on `iOS`;   **Note:** to use this parameter, set `calculate_rectangles` to `true` |
| `url` | string | *direct URL of the search query*   optional field   you can specify a direct URL and we will sort it out to the necessary fields. Note that this method is the most difficult for our API to process and also requires you to specify the exact language and location in the URL. In most cases, we wouldn’t recommend using this method.   example:   `https://www.bing.com/search?q=rank%20checker&count=50&first=1&setlang=en&cc=US&safesearch=Moderate&FORM=SEPAGE` |
| `location_coordinate` | string | *GPS coordinates of a location*   **required field if you don't specify** `location_name` or `location_code`   **if you use this field, you don't need to specify `location_name` or `location_code`**   `location_coordinate` parameter should be specified in the *"latitude,longitude"* format   the maximum number of decimal digits for *"latitude"* and *"longitude"*: 7   example:   `53.476225,-2.243572` |

    
  
As a response of the API server, you will receive [JSON](https://en.wikipedia.org/wiki/JSON)-encoded data containing a `tasks` array with the information specific to the set tasks. **Description of the fields in the results array:**

| Field name | Type | Description |
|---|---|---|
| `version` | string | *the current version of the API* |
| `status_code` | integer | *general status code*   you can find the full list of the response codes [here](https://docs.dataforseo.com/v3/appendix/errors.md)   **Note:** we strongly recommend designing a necessary system for handling related exceptional or error conditions |
| `status_message` | string | *general informational message*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *total tasks cost, USD* |
| `tasks_count` | integer | *the number of tasks in the **`tasks`** array* |
| `tasks_error` | integer | *the number of tasks in the **`tasks`** array returned with an error* |
| **`tasks`** | array | *array of tasks* |
| `id` | string | *task identifier*   **unique task identifier in our system in the [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format** |
| `status_code` | integer | *status code of the task*   generated by DataForSEO; can be within the following range: 10000-60000   you can find the full list of the response codes [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `status_message` | string | *informational message of the task*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *cost of the task, USD* |
| `result_count` | integer | *number of elements in the `result` array* |
| `path` | array | *URL path* |
| `data` | object | *contains the same parameters that you specified in the POST request* |
| **`result`** | array | *array of results* |
| `keyword` | string | *keyword received in a POST array* **the keyword is returned with decoded %## (plus character ‘+’ will be decoded to a space character)** |
| `type` | string | *search engine type in a POST array* |
| `se_domain` | string | *search engine domain in a POST array* |
| `location_code` | integer | *location code in a POST array* |
| `language_code` | string | *language code in a POST array* |
| `check_url` | string | *direct URL to search engine results*   you can use it to make sure that we provided accurate results |
| `datetime` | string | *date and time when the result was received*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example:   `2019-11-15 12:57:46 +00:00` |
| `spell` | object | *autocorrection of the search engine*   if the search engine provided results for a keyword that was corrected, we will specify the keyword corrected by the search engine and the type of autocorrection   equals `null` |
| `refinement_chips` | object | *search refinement chips*   equals `null` |
| `item_types` | array | *types of search results in SERP*   contains types of search results (`items`) found in SERP.   possible item types:   [`answer_box`](#answer_box), [`carousel`](#carousel), [`events`](#events), [`featured_snippet`](#featured_snippet), [`hotels_pack`](#hotels), [`images`](#images), [`jobs`](#jobs), [`local_pack`](#local_pack), [`map`](#map), [`organic`](#organic), [`paid`](#paid), [`people_also_ask`](#people_also_ask), [`people_also_search`](#people_also_search), [`questions_and_answers`](#questions_and_answers),[`recipes`](#recipes), [`related_searches`](#related_searches), [`shopping`](#shopping), [`top_stories`](#top_stories), [`video`](#video), [`ai_overview`](#ai_overview) |
| `se_results_count` | integer | *total number of results in SERP* |
| `pages_count` | integer | *total pages retrieved*   total number of retrieved SERPs in the result |
| `items_count` | integer | *the number of results returned in the **`items`** array* |
| **`items`** | array | *elements of search results found in SERP* |
| **<a name="organic"></a>[‘organic’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/organic_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘organic’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `domain` | string | *domain in SERP* |
| `title` | string | *title of the result in SERP* |
| `url` | string | *relevant URL in SERP* |
| `cache_url` | string | *cached version of the page* |
| `related_search_url` | string | *URL to a similar search*   URL to a new search for the same keyword(s) on related sites |
| `breadcrumb` | string | *breadcrumb in SERP* |
| `website_name` | string | *relevant website name in SERP* |
| `is_image` | boolean | *indicates whether the element contains an `image`* |
| `is_video` | boolean | *indicates whether the element contains a `video`* |
| `is_featured_snippet` | boolean | *indicates whether the element is a `featured_snippet`* |
| `is_malicious` | boolean | *indicates whether the element is marked as malicious* |
| `is_web_story` | boolean | *indicates whether the element is marked as a web story* |
| `description` | string | *description of the results element in SERP* |
| `pre_snippet` | string | *includes additional information appended before the result description in SERP* |
| `extended_snippet` | string | *includes additional information appended after the result description in SERP* |
| `images` | array | *images of the element* |
| `type` | string | *type of element = ‘**images\_element**‘* |
| `alt` | string | *alt tag of the image* |
| `url` | string | *relevant URL* |
| `image_url` | string | *URL of the image*   the URL leading to the image on the original resource or DataForSEO storage (in case the original source is not available) |
| `amp_version` | boolean | *Accelerated Mobile Pages*   indicates whether an item has the Accelerated Mobile Page (AMP) version |
| `rating` | object | *the item’s rating*    the popularity rate based on reviews and displayed in SERP |
| `rating_type` | string | *the type of rating*   here you can find the following elements: `Max5`, `Percents`, `CustomMax` |
| `value` | float | *the value of the rating* |
| `votes_count` | integer | *the amount of feedback* |
| `rating_max` | integer | *the maximum value for a `rating_type`* |
| `price` | object | *pricing details*   contains the pricing details of the product or service featured in the result |
| `current` | float | *current price*   indicates the current price of the product or service featured in the result |
| `regular` | float | *regular price*   indicates the regular price of the product or service with no discounts applied |
| `max_value` | float | *the maximum price*   the maximum price of the product or service as indicated in the result |
| `currency` | string | *currency of the listed price*   ISO code of the currency applied to the price |
| `is_price_range` | boolean | *price is provided as a range*   indicates whether a price is provided in a range |
| `displayed_price` | string | *price string in the result*   raw price string as provided in the result |
| `highlighted` | array | *words highlighted in bold within the results `description`* |
| `links` | array | *sitelinks*   the links shown below some search results   if there are none, equals `null` |
| `type` | string | *type of element = ‘**link\_element**‘* |
| `title` | string | *title of the result in SERP* |
| `description` | string | *description of the results element in SERP* |
| `url` | string | *sitelink URL* |
| `faq` | object | *frequently asked questions*   questions and answers extension shown below some search results   if there are none, equals `null` |
| `type` | string | *type of element = ‘**faq\_box**‘* |
| `items` | array | *items featured in the faq\_box* |
| `type` | string | *type of element = ‘**faq\_box\_element**‘* |
| `title` | string | *question related to the result* |
| `description` | string | *answer provided in the drop-down block* |
| `links` | array | *links featured in the faq\_box\_element* |
| `type` | string | *type of element = ‘**link\_element**‘* |
| `title` | string | *link anchor text* |
| `url` | string | *link URL* |
| `extended_people_also_search` | array | *extension of the organic element*   extension of the organic result containing related search queries   **Note:** extension appears in SERP upon clicking on the result and then bouncing back to search results |
| `about_this_result` | object | *contains information from the ‘About this result’ panel*   **note:** `about_this_result` feature is not available in Bing search engine, that’s why it always equals `null` |
| `related_result` | array | *related result from the same domain*   related result from the same domain appears as a part of the main result snippet;   **note:** `related_result` feature is not available in Bing search engine, that’s why it always equals `null` |
| `timestamp` | string | *date and time when the result was published*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example:   `2019-11-15 12:57:46 +00:00` |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="paid"></a>[‘paid’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/paid_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘paid’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `domain` | string | *domain in SERP of the Ad element* |
| `description` | string | *description of the results element in SERP* |
| `title` | string | *title of the result in SERP* |
| `url` | string | *relevant URL of the Ad element in SERP* |
| `breadcrumb` | string | *breadcrumb of the Ad element in SERP* |
| `highlighted` | array | *words highlighted in bold within the results `description`* |
| `extra` | object | *additional information about the result* |
| `ad_aclk` | string | *the identifier of the ad* |
| `description` | string | *description of the results element in SERP* |
| `description_rows` | array | *extended description*   if there is none, equals `null` |
| `links` | array | *sitelinks*   the links shown below some search results   if there are none, equals `null` |
| `type` | string | *type of element = ‘**link\_element**‘* |
| `title` | string | *title of the link element* |
| `description` | string | *description of the results element in SERP* |
| `url` | string | *URL link* |
| `ad_aclk` | string | *the identifier of the ad* |
| `price` | object | *pricing details*   contains the pricing details of the product or service featured in the result |
| `current` | float | *current price*   indicates the current price of the product or service featured in the result |
| `regular` | float | *regular price*   indicates the regular price of the product or service with no discounts applied |
| `max_value` | float | *the maximum price*   the maximum price of the product or service as indicated in the result |
| `currency` | string | *currency of the listed price*   ISO code of the currency applied to the price |
| `is_price_range` | boolean | *price is provided as a range*   indicates whether a price is provided in a range |
| `displayed_price` | string | *price string in the result*   raw price string as provided in the result |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="answer_box"></a>[‘answer\_box’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/answer_box_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘answer\_box’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `text` | array | *text*   if there is none, equals `null` |
| `links` | array | *sitelinks*   the links shown below some search results   if there are none, equals `null` |
| `type` | string | *type of element = ‘**link\_element**‘* |
| `title` | string | *title of the link* |
| `description` | string | *description of the results element in SERP* |
| `url` | string | *URL link* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="related_searches"></a>[‘related\_searches’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/related-searches_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘related\_searches’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="people_also_search"></a>‘people\_also\_search’ element in SERP** |  |  |
| `type` | string | *type of element = **‘people\_also\_search’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `title` | string | *title of the result in SERP* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="local_pack"></a>[‘local\_pack’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/local-pack_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘local\_pack’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `title` | string | *title of the result in SERP* |
| `description` | string | *description of the results element in SERP* |
| `domain` | string | *domain in SERP* |
| `phone` | string | *phone number* |
| `url` | string | *relevant URL* |
| `is_paid` | boolean | *indicates whether the element is an ad* |
| `rating` | object | *the item’s rating*    the popularity rate based on reviews and displayed in SERP |
| `rating_type` | string | *the type of rating*   here you can find the following elements: `Max5`, `Percents`, `CustomMax` |
| `value` | float | *the value of the rating* |
| `votes_count` | integer | *the amount of feedback* |
| `rating_max` | integer | *the maximum value for a `rating_type`* |
| `cid` | string | *bing-defined client id*   unique id of a local establishment |
| `is_claimed` | boolean | *business listing is claimed*   if `true`, the business listing is claimed by the owner or representative |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="hotels"></a>[‘hotels\_pack’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/hotels-pack_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘hotels\_pack’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `title` | string | *title of the result in SERP* |
| `date_from` | string | *starting date of stay*   in the format “year-month-date”   example:   2019-11-15 |
| `date_to` | string | *ending date of stay*   in the format “year-month-date”   example:   2019-11-17 |
| `items` | array | *contains results featured in the ‘hotels\_pack’ element of SERP* |
| `type` | string | *type of element = **‘hotels\_pack\_element’*** |
| `price` | object | *price of booking a place for the specified dates of stay* |
| `current` | float | *current price*   indicates the current price of booking a place for the specified dates of stay |
| `regular` | float | *regular price*   indicates the regular price of booking a place for the specified dates of stay |
| `max_value` | float | *the maximum price*   the maximum price of booking a place for the specified dates of stay |
| `currency` | string | *currency of the listed price*   ISO code of the currency applied to the price |
| `is_price_range` | boolean | *price is provided as a range*   indicates whether a price is provided in a range |
| `displayed_price` | string | *price string in the result*   raw price string as provided in the result |
| `title` | string | *title of the place* |
| `desription` | string | *description of the place in SERP* |
| `hotel_identifier` | string | *unique hotel identifier*   unique hotel identifier assigned by Bing;   example: `"CgoIjaeSlI6CnNpVEAE"` |
| `domain` | string | *domain in SERP* |
| `url` | string | *relevant URL* |
| `is_paid` | boolean | *indicates whether the element is an ad* |
| `rating` | object | *the item’s rating*    the popularity rate based on reviews and displayed in SERP |
| `rating_type` | string | *the type of rating*   here you can find the following elements: `Max5`, `Percents`, `CustomMax` |
| `value` | float | *the value of the rating* |
| `votes_count` | integer | *the amount of feedback* |
| `rating_max` | integer | *the maximum value for a `rating_type`* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="carousel"></a>[‘carousel’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/carousel_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘carousel’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `title` | string | *title of the result in SERP* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**carousel\_element**‘* |
| `title` | string | *title of the item* |
| `subtitle` | string | *subtitle of the item* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="events"></a>[‘events’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/events_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘events’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `title` | string | *title of the result in SERP* |
| `url` | string | *URL* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**events\_element**‘* |
| `title` | string | *title of the item* |
| `description` | string | *snippet of the element* |
| `url` | string | *`events_element` URL* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="featured_snippet"></a>[‘featured\_snippet’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/featured-snippet_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘featured\_snippet’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `domain` | string | *domain in SERP* |
| `title` | string | *title of the result in SERP* |
| `featured_title` | string | *the title of the featured snippets source page* |
| `description` | string | *description of the results element in SERP* |
| `timestamp` | string | *date and time when the result was published*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example:   `2019-11-15 12:57:46 +00:00` |
| `url` | string | *relevant URL* |
| `images` | array | *images of the element* |
| `type` | string | *type of element = ‘**images\_element**‘* |
| `alt` | string | *alt tag of the image* |
| `url` | string | *relevant URL* |
| `image_url` | string | *URL of the image*   the URL leading to the image on the original resource or DataForSEO storage (in case the original source is not available) |
| `table` | object | *results table*   if there are none, equals `null` |
| `table_header` | array | *column names* |
| `table_content` | array | *the content of the table*   one line of the table in this element of the array |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="images"></a>[‘images’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/images_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘images’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `title` | string | *title of the result in SERP* |
| `url` | string | *relevant URL* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**images\_element**‘* |
| `alt` | string | *alt tag of the image* |
| `url` | string | *original URL of the image*   the URL leading to the image on the original resource |
| `image_url` | string | *URL to the compressed image*   the URL leading to the image on DataForSEO storage |
| `related_image_searches` | array | *contains keywords and images related to the specified search term*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**related\_image\_searches\_element**‘* |
| `title` | string | *title of the element*   indicates keyword that may be used with the specified term to refine image search |
| `alt` | string | *alt tag of the featured image* |
| `url` | string | *original URL of the featured image*   the URL leading to the image on the original resource |
| `image_url` | string | *URL to the compressed featured image*   the URL leading to the image on DataForSEO storage |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="shopping"></a>[‘shopping’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/shopping_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘shopping’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `title` | string | *title of the result in SERP* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**shopping\_element**‘* |
| `title` | string | *title of the result in SERP* |
| `price` | object | *price of the shopping element* |
| `current` | float | *current price*   indicates the current price of the shopping element |
| `regular` | float | *regular price*   indicates the regular price of the shopping element |
| `max_value` | float | *the maximum price*   indicates the maximum price of the shopping element |
| `currency` | string | *currency of the listed price*   ISO code of the currency applied to the price |
| `is_price_range` | boolean | *price is provided as a range*   indicates whether a price is provided in a range |
| `displayed_price` | string | *price string in the result*   raw price string as provided in the result |
| `source` | string | *source of the element*   indicates the source of information included in the `shopping_element` |
| `description` | string | *the description of the results element in SERP* |
| `marketplace` | string | *merchant account provider*   commerce site that hosts products or websites of individual sellers under the same merchant account   example:   `by Bing` |
| `marketplace_url` | string | *relevant marketplace URL*   URL of the page on the marketplace website where the product is hosted |
| `url` | string | *URL* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="jobs"></a>[‘jobs’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/jobs_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘jobs’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `title` | string | *title of the result in SERP* |
| `url` | string | *URL* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**jobs\_element**‘* |
| `title` | string | *title of the result in SERP* |
| `description` | string | *description* |
| `location` | string | *location for which the job vacancy is posted* |
| `author` | string | *author* |
| `job_posted_time` | string | *the time when the job was posted* |
| `timestamp` | string | *date and time when the result was published*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example:   `2019-11-15 12:57:46 +00:00` |
| `contract_type` | string | *contract type* |
| `salary` | string | *salary* |
| `url` | string | *URL* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="map"></a>[‘map’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/map_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘map’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `title` | string | *title of the result in SERP* |
| `url` | string | *URL* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="people_also_ask"></a>[‘people\_also\_ask’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/people-also-ask_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘people\_also\_ask’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**people\_also\_ask\_element**‘* |
| `title` | string | *title of the result in SERP* |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `expanded_element` | array | *expanded element* |
| `type` | string | *type of element = ‘**people\_also\_ask\_expanded\_element**‘* |
| `featured_title` | string | *title* |
| `url` | string | *relevant URL* |
| `domain` | string | *domain in SERP* |
| `title` | string | *title of the result in SERP* |
| `description` | string | *description of the results element in SERP* |
| `timestamp` | string | *date and time when the result was published*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example:   `2019-11-15 12:57:46 +00:00` |
| `table` | object | *results table*   if there are none, equals `null` |
| `table_header` | array | *column names* |
| `table_content` | array | *the content of the table*   one line of the table in this element of the array |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="questions_and_answers"></a>‘questions\_and\_answers’ element in SERP** |  |  |
| `type` | string | *type of element = **‘questions\_and\_answers’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**questions\_and\_answers\_element**‘* |
| `url` | string | *`questions_and_answers_element` URL* |
| `question_text` | string | *question included in the item* |
| `answer_text` | string | *answer included in the item* |
| `source` | string | *source of the element*   indicates the source of information included in the `questions_and_answers_element` |
| `domain` | string | *domain name of the source* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="recipes"></a>[‘recipes’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/recipes_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘recipes’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**recipes\_element**‘* |
| `title` | string | *title of the item* |
| `url` | string | *`recipes_element` URL* |
| `domain` | string | *domain in SERP* |
| `source` | string | *source of the element*   indicates the source of information included in the `recipes_element` |
| `description` | string | *snippet of the element* |
| `time` | string | *the total time it takes to prepare the cook the dish* |
| `rating` | object | *the item’s rating*   the popularity rate based on reviews and displayed in SERP |
| `rating_type` | string | *the type of rating*   here you can find the following elements: `Max5`, `Percents`, `CustomMax` |
| `value` | float | *the value of the rating* |
| `votes_count` | integer | *the amount of feedback* |
| `rating_max` | integer | *the maximum value for a `rating_type`* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="top_stories"></a>[‘top\_stories’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/top-stories_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘top\_stories’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**top\_stories\_element**‘* |
| `source` | string | *source of the element*   indicates the source of information included in the `top_stories_element` |
| `domain` | string | *domain in SERP* |
| `title` | string | *title of the result in SERP* |
| `date` | string | *the date when the page source of the element was published* |
| `amp_version` | boolean | *Accelerated Mobile Pages*   indicates whether an item has the Accelerated Mobile Page (AMP) version |
| `timestamp` | string | *date and time when the result was published*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example:   `2019-11-15 12:57:46 +00:00` |
| `url` | string | *URL* |
| `image_url` | string | *URL of the image*   the URL leading to the image on the original resource or DataForSEO storage (in case the original source is not available) |
| `badges` | array | *badges relevant to the element* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="video"></a>[‘video’ element in SERP![](https://dataforseo.com/wp-content/uploads/2022/02/video_bing.png)](#)** |  |  |
| `type` | string | *type of element = **‘video’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `items` | array | *additional items present in the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**video\_element**‘* |
| `source` | string | *source of the element*   indicates the source of the video |
| `title` | string | *title of the result in SERP* |
| `timestamp` | string | *date and time when the result was published*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example:   `2019-11-15 12:57:46 +00:00` |
| `url` | string | *URL* |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |
| **<a name="ai_overview"></a>[‘ai\_overview’ element in SERP![](https://docs.dataforseo.com/v3/wp-content/uploads/2025/04/copilot_search.png)](#)** |  |  |
| `type` | string | *type of element = **‘ai\_overview’*** |
| `rank_group` | integer | *group rank in SERP*   position within a group of elements with identical `type` values   positions of elements with different `type` values are omitted from `rank_group` |
| `rank_absolute` | integer | *absolute rank in SERP*   absolute position among all the elements in SERP |
| `page` | integer | *search results page number*   indicates the number of the SERP page on which the element is located |
| `position` | string | *the alignment of the element in SERP*   can take the following values:   `left`, `right` |
| `xpath` | string | *the [XPath](https://en.wikipedia.org/wiki/XPath) of the element* |
| `markdown` | string | *content of the element in markdown format* |
| `items` | array | *items present in the element* |
| `type` | string | *type of element = ‘**ai\_overview\_element**‘* |
| `title` | string | *title of the element* |
| `text` | string | *text or description of the element in SERP* |
| `images` | array | *images of the element*   if there are none, equals `null` |
| `type` | string | *type of element = ‘**images\_element**‘* |
| `alt` | string | *alt tag of the image* |
| `url` | string | *relevant URL* |
| `image_url` | string | *URL of the image*   the URL leading to the image on the original resource or DataForSEO storage (in case the original source is not available) |
| `references` | array | *references relevant to the element*   includes references to webpages that were used to generate the `ai_overview_element` |
| `type` | string | *type of element = ‘**ai\_overview\_reference**‘* |
| `source` | string | *reference source name or title* |
| `domain` | string | *domain name of the reference* |
| `url` | string | *reference page URL* |
| `title` | string | *reference page title* |
| `text` | string | *reference text*   text snippet from the page that was used to generate the `ai_overview_element` |
| `type` | string | *type of element = ‘**ai\_overview\_video\_element**‘* |
| `position` | string | *the alignment of the element in SERP*   can take the following values: `left`, `right` |
| `title` | string | *title of the video* |
| `snippet` | string | *text snippet of the video* |
| `url` | string | *URL of the video* |
| `domain` | string | *domain where the video is hosted* |
| `image_url` | string | *URL of the video thumbnail image* |
| `source` | string | *source of the video*   indicates the video platform   example: `YouTube` |
| `date` | string | *date when the video was published*   example: `Jan 1, 2009` |
| `timestamp` | string | *date and time when the video was published*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example: `2009-01-01 00:00:00 +00:00` |
| `type` | string | *type of element = ‘**ai\_overview\_videos\_element**‘* |
| `items` | array | *array of video items&lt;/em* |
| `type` | string | *type of element = ‘**video\_element**‘* |
| `url` | string | *URL of the video* |
| `title` | string | *title of the video* |
| `source` | string | *source of the video*   indicates the video platform   example: `YouTube` |
| `timestamp` | string | *date and time when the video was published*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example: `2009-01-01 00:00:00 +00:00` |
| `type` | string | *type of element = ‘**ai\_overview\_images\_element**‘* |
| `url` | string | *URL to view more images*   leads to Bing Images search results |
| `title` | string | *title of the image collection* |
| `items` | array | *array of image items* |
| `type` | string | *type of element = ‘**image\_element**‘* |
| `alt` | string | *alt text of the image* |
| `url` | string | *URL of the image source* |
| `image_url` | string | *direct URL of the image* |
| `type` | string | *type of element = ‘**ai\_overview\_organic\_element**‘* |
| `title` | string | *title of the organic result* |
| `url` | string | *URL of the organic result* |
| `domain` | string | *domain of the organic result* |
| `snippet` | string | *text snippet from the organic result* |
| `breadcrumb` | string | *breadcrumb navigation of the organic result* |
| `website_name` | string | *name of the source website* |
| `links` | array | *links featured in the organic result* |
| `type` | string | *type of element = ‘**link\_element**‘* |
| `title` | string | *title of the link element* |
| `description` | string | *link description* |
| `url` | string | *link URL* |
| `domain` | string | *domain in SERP* |
| `highlighted` | array | *highlighted keywords in the text snippet* |
| `references` | array | *additional references relevant to the item*   includes references to webpages that may have been used to generate the `ai_overview` |
| `type` | string | *type of element = ‘**ai\_overview\_reference**‘* |
| `source` | string | *reference source name or title* |
| `domain` | string | *domain name of the reference* |
| `url` | string | *reference page URL* |
| `title` | string | *reference page title* |
| `text` | string | *reference text*   text snippet from the page that was used to generate the `ai_overview_element` |
| `rectangle` | object | *rectangle parameters*   contains cartesian coordinates and pixel dimensions of the result’s snippet in SERP   equals `null` if `calculate_rectangles` in the POST request is not set to `true` |
| `x` | integer | *x-axis coordinate*   x-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `y` | integer | *y-axis coordinate*   y-axis coordinate of the top-left corner of the result’s snippet, where top-left corner of the screen is the origin |
| `width` | integer | *width of the element in pixels* |
| `height` | integer | *height of the element in pixels* |



 

 









> Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

```
# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/serp/bing/organic/live/advanced" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "language_code": "en",
        "location_code": 2840,
        "keyword": "flight ticket new york san francisco"
    }
]'
```





```php
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
	// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
	$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
	exit();
}
$post_array = array();
// You can set only one task at a time
$post_array[] = array(
	"language_code" => "en",
	"location_code" => 2840,
	"keyword" => mb_convert_encoding("flight ticket new york san francisco", "UTF-8")
);
try {
	// POST /v3/serp/bing/organic/live/advanced
	// in addition to 'bing' and 'organic' you can also set other search engine and type parameters
	// the full list of possible parameters is available in documentation
	$result = $client->post('/v3/serp/bing/organic/live/advanced', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
```





```js
const axios = require('axios');

axios({
    method: 'post',
    url: 'https://api.dataforseo.com/v3/serp/bing/organic/live/advanced',
    auth: {
        username: 'login',
        password: 'password'
    },
    data: [{
        "keyword": encodeURI("flight ticket new york san francisco"),
        "language_code": "en",
        "location_code": 2840
    }],
    headers: {
        'content-type': 'application/json'
    }
}).then(function (response) {
    var result = response['data']['tasks'];
    // Result data
    console.log(result);
}).catch(function (error) {
    console.log(error);
});
```





```python
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# You can set only one task at a time
post_data[len(post_data)] = dict(
    language_code="en",
    location_code=2840,
    keyword="flight ticket new york san francisco"
)
# POST /v3/serp/bing/organic/live/advanced
# in addition to 'bing' and 'organic' you can also set other search engine and type parameters
# the full list of possible parameters is available in documentation
response = client.post("/v3/serp/bing/organic/live/advanced", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
```





```csharp
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task serp_live_advanced()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                //DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            // You can set only one task at a time
            postData.Add(new
            {
                language_code = "en",
                location_code = 2840,
                keyword = "flight ticket new york san francisco"
            });
            // POST /v3/serp/bing/organic/live/advanced
            // in addition to 'bing' and 'organic' you can also set other search engine and type parameters
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/serp/bing/organic/live/advanced", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}
```





> The above command returns JSON structured like this:

```
{
  "version": "0.1.20200129",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.2347 sec.",
  "cost": 0,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "01291734-1535-0066-0000-6988734166f9",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "0.0934 sec.",
      "cost": 0,
      "result_count": 1,
      "path": [
        "v3",
        "serp",
        "bing",
        "organic",
        "advanced",
        "live",
        "01291734-1535-0066-0000-6988734166f9"
      ],
      "data": {
        "api": "serp",
        "function": "task_get",
        "se": "bing",
        "se_type": "organic",
        "language_name": "English",
        "location_name": "United States",
        "keyword": "flight ticket new york san francisco",
        "tag": "tag2",
        "device": "desktop",
        "os": "windows"
      },
      "result": [
        {
          "keyword": "star wars cast",
          "type": "organic",
          "se_domain": "bing.com",
          "location_code": 2840,
          "language_code": "en",
          "check_url": "https://www.bing.com/search?q=star%20wars%20cast&count=50&first=1&setlang=en&cc=US&safesearch=Moderate&form=QBLH",
          "datetime": "2022-01-28 13:46:40 +00:00",
          "spell": null,
          "refinement_chips": null,
          "item_types": [
            "organic",
            "images",
            "top_stories",
            "video",
            "related_searches",
            "carousel",
            "paid",
            "ai_overview"
          ],
          "se_results_count": 99148,
          "pages_count": 1,
          "items_count": 110,
          "items": [
            {
              "type": "carousel",
              "rank_group": 1,
              "rank_absolute": 1,
              "page": 1,
              "position": "left",
              "xpath": "/html[1]/body[1]/div[1]/main[1]/div[1]/div[1]/div[2]",
              "title": "Star Wars - Cast",
              "items": [
                {
                  "type": "carousel_element",
                  "title": "George Lucas",
                  "subtitle": "Born 1944"
                },
                {
                  "type": "carousel_element",
                  "title": "Mark Hamill",
                  "subtitle": "Born 1951"
                },
                {
                  "type": "carousel_element",
                  "title": "Carrie Fisher",
                  "subtitle": "1956 - 2016"
                },
                {
                  "type": "carousel_element",
                  "title": "Hayden Christensen",
                  "subtitle": "Born 1981"
                },
                {
                  "type": "carousel_element",
                  "title": "Daisy Ridley",
                  "subtitle": "Born 1992"
                }
              ],
              "rectangle": {
                "x": 160,
                "y": 571,
                "width": 648,
                "height": 986
              }
            },
            {
              "type": "organic",
              "rank_group": 1,
              "rank_absolute": 2,
              "page": 1,
              "position": "left",
              "xpath": "/html[1]/body[1]/div[1]/main[1]/ol[1]/li[1]",
              "domain": "www.imdb.com",
              "title": "Star Wars Cast(1977-Present) - IMDb",
              "url": "https://www.imdb.com/list/ls070679507/",
              "cache_url": null,
              "related_search_url": null,
              "breadcrumb": "https://www.imdb.com/list/ls070679507",
              "website_name": "IMDb",
              "is_image": false,
              "is_video": false,
              "is_featured_snippet": false,
              "is_malicious": false,
              "is_web_story": false,
              "description": "Star Wars Cast (1977-Present) 1. Mark Hamill. Actor | Star Wars. Mark Hamill is best known for his portrayal of Luke Skywalker in the original Star Wars trilogy - Star Wars: ... 2. Harrison Ford. 3. Carrie Fisher. 4. Billy Dee Williams. 5. Alec Guinness.",
              "pre_snippet": null,
              "extended_snippet": null,
              "images": null,
              "amp_version": false,
              "rating": null,
              "price": null,
              "highlighted": [
                "Mark Hamill.",
                "Mark Hamill",
                "Luke Skywalker"
              ],
              "links": null,
              "faq": null,
              "extended_people_also_search": null,
              "about_this_result": null,
              "related_result": null,
              "timestamp": null,
              "rectangle": {
                "x": 160,
                "y": 571,
                "width": 648,
                "height": 986
              }
            },
            {
              "type": "images",
              "rank_group": 1,
              "rank_absolute": 4,
              "page": 1,
              "position": "left",
              "xpath": "/html[1]/body[1]/div[1]/main[1]/ol[1]/li[3]",
              "title": "Images of Star Wars Cast",
              "url": "https://www.bing.com/images/search?q=star+wars+cast&qpvt=star+wars+cast&tsc=ImageHoverTitle&FORM=IGRE",
              "items": [
                {
                  "type": "images_element",
                  "alt": "Image result for Star Wars Cast. Size: 176 x 170. Source: www.blackfilm.com",
                  "url": "https://www.blackfilm.com/read/2017/12/recapping-star-wars-last-jedi-press-conference/",
                  "image_url": "https://api.dataforseo.com/cdn/i/01281546-1535-0139-0000-57efd54f6fd8:0"
                },
                {
                  "type": "images_element",
                  "alt": "Image result for Star Wars Cast. Size: 176 x 170. Source: www.therichest.com",
                  "url": "https://www.therichest.com/pop-culture/cast-member-star-wars-net-worth/",
                  "image_url": "https://api.dataforseo.com/cdn/i/01281546-1535-0139-0000-57efd54f6fd8:1"
                },
                {
                  "type": "images_element",
                  "alt": "Image result for Star Wars Cast. Size: 176 x 170. Source: www.cheatsheet.com",
                  "url": "https://www.cheatsheet.com/entertainment/star-wars-the-rise-of-skywalker-final-trailer-all-the-easter-eggs-you-may-have-missed.html/",
                  "image_url": "https://api.dataforseo.com/cdn/i/01281546-1535-0139-0000-57efd54f6fd8:2"
                },
                {
                  "type": "images_element",
                  "alt": "Image result for Star Wars Cast. Size: 176 x 170. Source: www.blackfilm.com",
                  "url": "https://www.blackfilm.com/read/2019/12/j-j-abrams-the-cast-of-star-wars-the-rise-of-skywalker-talk-landing-the-final-skywalker-saga-vehicle/",
                  "image_url": "https://api.dataforseo.com/cdn/i/01281546-1535-0139-0000-57efd54f6fd8:3"
                },
                {
                  "type": "images_element",
                  "alt": "Image result for Star Wars Cast. Size: 176 x 170. Source: io9.gizmodo.com",
                  "url": "http://io9.gizmodo.com/cast-of-star-wars-the-last-jedi-takes-over-vanity-fair-1795461250",
                  "image_url": "https://www.bing.com/th?id=OIP.kdF2M7uR8MfXQ33UycMOgQHaEK&w=176&h=170&c=8&rs=1&qlt=90&o=6&pid=3.1&rm=2"
                }
              ],
              "related_image_searches": [
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars Actors",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+Actors&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars 9 Cast",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+9+Cast&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars Episode 9 Cast",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+Episode+9+Cast&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars 8 Characters",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+8+Characters&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars 7 Characters",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+7+Characters&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars 4 Cast",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+4+Cast&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars Full Cast",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+Full+Cast&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars Female Cast",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+Female+Cast&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars 1 Cast",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+1+Cast&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars Episode 2 Cast",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+Episode+2+Cast&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars Movie Characters",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+Movie+Characters&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Original Star Wars Actors",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Original+Star+Wars+Actors&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars Cast Anakin",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+Cast+Anakin&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars Clone Wars Cast",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+Clone+Wars+Cast&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                },
                {
                  "type": "related_image_searches_element",
                  "title": "Star Wars Actors List",
                  "alt": null,
                  "url": null,
                  "image_url": "/th?q=Star+Wars+Actors+List&w=100&h=100&c=7&o=5&pid=1.7&mkt=en-US&cc=US&setlang=en&adlt=moderate"
                }
              ],
              "rectangle": {
                "x": 160,
                "y": 571,
                "width": 648,
                "height": 986
              }
            },
            {
              "type": "top_stories",
              "rank_group": 1,
              "rank_absolute": 7,
              "page": 1,
              "position": "left",
              "xpath": "/html[1]/body[1]/div[1]/main[1]/ol[1]/li[6]",
              "title": "News about Star Wars Cast",
              "items": [
                {
                  "type": "top_stories_element",
                  "source": "Cinema Blend",
                  "domain": "www.cinemablend.com",
                  "title": "Star Wars Galactic Starcruiser Is Prepping For Launch, Here’s Our First Look At The Crew",
                  "date": "· 9h",
                  "amp_version": false,
                  "timestamp": null,
                  "url": "https://www.cinemablend.com/movies/star-wars-galactic-starcruiser-is-prepping-for-launch-heres-our-first-look-at-the-crew",
                  "image_url": null,
                  "badges": null
                },
                {
                  "type": "top_stories_element",
                  "source": "GameSpot",
                  "domain": "www.gamespot.com",
                  "title": "New Footage Of Canceled Star Wars 1313 Game Shows Boba Fett On The Hunt",
                  "date": "· 22h",
                  "amp_version": false,
                  "timestamp": null,
                  "url": "https://www.gamespot.com/articles/new-footage-of-canceled-star-wars-1313-game-shows-boba-fett-on-the-hunt/1100-6500019/",
                  "image_url": null,
                  "badges": null
                },
                {
                  "type": "top_stories_element",
                  "source": "theblast",
                  "domain": "theblast.com",
                  "title": "Mary Elizabeth Winstead Cast In ‘Star Wars’ Ahsoka Series",
                  "date": "· 6d",
                  "amp_version": false,
                  "timestamp": null,
                  "url": "https://theblast.com/164070/mary-elizabeth-winstead-casting/",
                  "image_url": null,
                  "badges": null
                }
              ],
              "rectangle": {
                "x": 160,
                "y": 571,
                "width": 648,
                "height": 986
              }
            },
            {
              "type": "video",
              "rank_group": 1,
              "rank_absolute": 10,
              "page": 1,
              "position": "left",
              "xpath": "/html[1]/body[1]/div[1]/main[1]/ol[1]/li[9]",
              "items": [
                {
                  "type": "video_element",
                  "source": "Microsoft NewsABC",
                  "title": "Star Wars Cast Plays Family Feud",
                  "timestamp": "2019-12-16 00:00:00 +00:00",
                  "url": null
                },
                {
                  "type": "video_element",
                  "source": "Microsoft NewsABC",
                  "title": "Star Wars Cast Answers Questions From Kids",
                  "timestamp": "2019-12-16 00:00:00 +00:00",
                  "url": null
                },
                {
                  "type": "video_element",
                  "source": "YouTubeStar Wars",
                  "title": "Star Wars: The Force Awakens Trailer (Official)",
                  "timestamp": "2015-10-20 00:00:00 +00:00",
                  "url": null
                },
                {
                  "type": "video_element",
                  "source": "YouTubeBuzzFeed Celeb",
                  "title": "Star Wars Cast Takes "Which Star Wars Character Are You?" Quiz",
                  "timestamp": "2017-12-12 00:00:00 +00:00",
                  "url": null
                },
                {
                  "type": "video_element",
                  "source": "YouTubeONE Media",
                  "title": "STAR WARS: THE BAD BATCH Trailer 2 (NEW, 2021) Disney",
                  "timestamp": "2021-04-28 13:46:33 +00:00",
                  "url": null
                }
              ],
              "rectangle": {
                "x": 160,
                "y": 571,
                "width": 648,
                "height": 986
              }
            },
            {
              "type": "people_also_ask",
              "rank_group": 1,
              "rank_absolute": 8,
              "page": 1,
              "position": "left",
              "xpath": "/html[1]/body[1]/div[1]/main[1]/ol[1]/li[9]",
              "items": [
                {
                  "type": "people_also_ask_element",
                  "title": "How popular is Star Wars?",
                  "xpath": "/html[1]/body[1]/div[1]/main[1]/ol[1]/li[9]/div[1]/div[1]/div[1]/div[1]/div[2]/div[1]/div[1]",
                  "expanded_element": [
                    {
                      "type": "people_also_ask_expanded_element",
                      "featured_title": null,
                      "url": "https://www.msn.com/en-us/movies/news/these-are-the-most-popular-star-wars-characters/ss-BB1glLna#:~:text=Star%20Wars%20is%20one%20of%20the%20most%20popular,Star%20Wars%20has%20always%20been%20its%20unforgettable%20characters.",
                      "domain": "www.msn.com",
                      "title": "These Are the Most Popular Star Wars Characters",
                      "description": "Star Wars is one of the most popular and long-running franchises in American media history, spawning three trilogies, spin-off films, comics, TV shows, video games, and more. Though many fans have been drawn in by the intense battle sequences and eye-popping visual effects, the heart of Star Wars has always been its unforgettable characters.",
                      "timestamp": null,
                      "table": null
                    }
                  ]
                },
                {
                  "type": "people_also_ask_element",
                  "title": "Who are the most popular characters in Star Wars?",
                  "xpath": "/html[1]/body[1]/div[1]/main[1]/ol[1]/li[9]/div[1]/div[1]/div[1]/div[1]/div[2]/div[1]/div[3]",
                  "expanded_element": [
                    {
                      "type": "people_also_ask_expanded_element",
                      "featured_title": null,
                      "url": "https://finance.yahoo.com/news/50-most-least-popular-star-211953052.html",
                      "domain": "finance.yahoo.com",
                      "title": "50 Most (and Least) Popular Star Wars Characters",
                      "description": "The most popular Wookie in the Star Wars films, Chewbacca is Han Solo’s lifelong friend and co-pilot of the Millenium Falcon. Based on Google search frequency, Chewbacca was the 201st most popular Halloween costume in 2017 and the sixth most popular costume of any Star Wars character.",
                      "timestamp": null,
                      "table": null
                    }
                  ]
                }
              ],
              "rectangle": {
                "x": 160,
                "y": 2964.3,
                "width": 648,
                "height": 260
              }
            },
            {
              "type": "local_pack",
              "rank_group": 1,
              "rank_absolute": 1,
              "page": 1,
              "position": "left",
              "xpath": "/html[1]/body[1]/div[1]/main[1]/ol[1]/li[1]/div[1]/div[1]/div[3]/div[2]",
              "title": "Angelo's Barber Shop",
              "description": "DIRECTIONS WEBSITE nn",
              "domain": "www.angelosbarbershop.com",
              "phone": null,
              "url": "https://www.angelosbarbershop.com/dtla--biltmore-hotel-",
              "is_paid": false,
              "rating": {
                "rating_type": "Max5",
                "value": 4.5,
                "votes_count": 11,
                "rating_max": 5
              },
              "cid": null,
              "is_claimed": true,
              "rectangle": {
                "x": 180,
                "y": 446,
                "width": 608,
                "height": 109
              }
            },
            {
              "type": "local_pack",
              "rank_group": 2,
              "rank_absolute": 2,
              "page": 1,
              "position": "left",
              "xpath": "/html[1]/body[1]/div[1]/main[1]/ol[1]/li[1]/div[1]/div[1]/div[3]/div[4]",
              "title": "Bolt Barbers",
              "description": "DIRECTIONS WEBSITE nn",
              "domain": "boltbarbers.com",
              "phone": null,
              "url": "http://boltbarbers.com/",
              "is_paid": false,
              "rating": {
                "rating_type": "Max5",
                "value": 5,
                "votes_count": 2,
                "rating_max": 5
              },
              "cid": null,
              "is_claimed": true,
              "rectangle": {
                "x": 180,
                "y": 567,
                "width": 608,
                "height": 109
              }
            },
            {
              "type": "map",
              "rank_group": 1,
              "rank_absolute": 2,
              "page": 1,
              "position": "left",
              "xpath": "/html[1]/body[1]/div[1]/main[1]/ol[1]/li[2]",
              "title": "Los Angeles, California",
              "url": "https://www.bing.com/maps?&ty=18&q=Los%20Angeles%2C%20California&satid=id.sid%3A9958ca5c-ea31-4e71-8a17-bd1e7839c723&vdpid=5059788015119892481&mb=34.401077~-118.917908~33.708313~-117.565002&ppois=34.05469512939453_-118.241455078125_Los%20Angeles%2C%20California_~&cp=34.054695~-118.241455&v=2&sV=1&FORM=MIRE&qpvt=la+city+map",
              "rectangle": {
                "x": 160,
                "y": 495,
                "width": 648,
                "height": 427
              }
            },
            {
              "type": "shopping",
              "rank_group": 1,
              "rank_absolute": 1,
              "page": 1,
              "position": "left",
              "xpath": "/html[1]/body[1]/div[1]/main[1]/div[2]/div[1]/ul[1]/li[1]",
              "title": "See star wars merch",
              "items": [
                {
                  "type": "shopping_element",
                  "title": "STAR WARS Jedi Master Yoda …Illuminated Desk Lamp By The Bradford Exchange",
                  "price": {
                    "current": 199.99,
                    "regular": null,
                    "max_value": null,
                    "currency": "USD",
                    "is_price_range": false,
                    "displayed_price": "$199.99"
                  },
                  "source": "Bradford Exchange",
                  "description": null,
                  "marketplace": null,
                  "marketplace_url": null,
                  "url": "https://www.bing.com/aclk?ld=e8qFvV9VcUMhyLj3DuLsIrnTVUCUwTcqcHjoJv3P8PVcIS9F9w3gZGJBqAMAEG6pJkDHP2n6875j9_EyEP8Qg7UUu9zXQNXY_683sB4k2CruGusHc4SGyKxdNaZsayqS-pPkEnZzJM5pSMBYe3ESgHjPf6RriMnnDSMZq07NQZknsV4oLouIeglB3IK33r2TaNFkSVvg&u=aHR0cHMlM2ElMmYlMmZhZC5hdGRtdC5jb20lMmZzJTJmZ28lM2JhZHYlM2QxMTEyNzIwMDkwNjM2NCUzYmVjJTNkMTExMjcyMDEwNjIzNjglM2JjLmElM2Q2MTc1NjU4MyUzYnMuYSUzZGdvb2dsZSUzYnAuYSUzZDYxNzU2NTgzJTNiYXMuYSUzZDEyNzMyMzUwNTI4MTUzMjQlM2JxcGIlM2QxJTNiJTNmYmlka3clM2RkZWZhdWx0a2V5d29yZCUyNmR2YyUzZGMlMjZoJTNkaHR0cHMlMjUzQSUyNTJGJTI1MkZ3d3cuYnJhZGZvcmRleGNoYW5nZS5jb20lMjUyRnByb2R1Y3RzJTI1MkYxMjIzNDgwMDFfc3Rhci13YXJzLWplZGktbWFzdGVyLXlvZGEtaWxsdW1pbmF0ZWQtZGVzay1sYW1wLmh0bWwlMjUzRmNtX3ZlbiUyNTNER1BTJTI1MjZjbV9jYXQlMjUzREJpbmclMjU3Q1Byb2R1Y3RBZHMlMjUyNmNtX3BsYSUyNTNENjE3NTY1ODMlMjU3QzEyNzMyMzUwNTI4MTUzMjQlMjUyNmNtX2l0ZSUyNTNEMTIyMzQ4MDAxJTI2bXNjbGtpZCUzZDhlYTUwZmY0MDM3MTE3OGQwZDlhNmUwN2Y1MmRlODM4JTI2dXRtX3NvdXJjZSUzZGJpbmclMjZ1dG1fbWVkaXVtJTNkY3BjJTI2dXRtX2NhbXBhaWduJTNkU2hvcHBpbmclMjUyMC0lMjUyMERDUiUyNnV0bV90ZXJtJTNkNDU4MzE3NjgwMTU2NDI2NyUyNnV0bV9jb250ZW50JTNkRENSJTI1MjAtJTI1MjBTb2xv&rlid=8ea50ff40371178d0d9a6e07f52de838"
                },
                {
                  "type": "shopping_element",
                  "title": "Boys Long-Sleeve Star Wars Print …Logo Graphic Tee In Cream | Size 9/10 | Abercrombie Kids",
                  "price": {
                    "current": 29.95,
[...]
